
getCPBalanceListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = ev.sub;
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.sub+"</td>");
        $("#"+indexStr).append("<td>"+ev.balance+"</td>");        
        $("#"+indexStr).append("<td>"+addBtnEdit(`editCPBalance('${ev.sub}')`)
                                       +addBtnDel(`delCPBalance('${ev.sub}')`)+"</td>");      
    });
    
};

getCPBalanceList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/cpbalance/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getCPBalanceListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getCPBalanceList);
};

gotoNextList=function() {
    pageNext(getCPBalanceList);
};

getCPBalanceDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#sub").val(ev.sub);
        $("#balance").val(ev.balance);        
    });
};

getCPBalanceDetail=function(sub) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("sub", sub);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/cpbalance/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getCPBalanceDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateCPBalanceDetail=function() {
    var jsonStr = "{";
            
    jsonStr += jsonEncodeString("sub", $("#sub").val())+",";
    jsonStr += jsonEncodeNumber("balance", $("#balance").val())+",";        
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/cpbalance/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiCPBalance.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiCPBalance.html");
        }
    });
};

delCPBalance=function(sub) {    
    var jsonStr = "{";
    jsonStr += jsonEncodeString("sub", sub)
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/cpbalance/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+sub).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiCPBalanceDlg.html");
};

editCPBalance=function(sub) {
    var dataPost = "sub="+encodeURIComponent(sub);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiCPBalanceDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiCPBalance.html");
};
