buildIndexStr=function(ipAddr) {
    return hex_md5("ipAddr="+ipAddr);
};


getIPBWListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.ipAddr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.ipAddr+"</td>");
        if( null != ev.description ) {    
            $("#"+indexStr).append("<td>"+ev.description+"</td>");
        }
        else {
            $("#"+indexStr).append("<td></td>");
        }
        $("#"+indexStr).append("<td>"+ipbwActionToStr(ev.action)+"</td>");
        $("#"+indexStr).append("<td>"+addBtnEdit(`editIPBWList('${ev.ipAddr}')`)
                                       +addBtnDel(`delIPBWList('${ev.ipAddr}')`)+"</td>");
    });    
};

getIPBWList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/ipbwlist/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getIPBWListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getIPBWList);
};

gotoNextList=function() {
    pageNext(getIPBWList);
};


getIPBWListDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#ipAddr").val(ev.ipAddr);
        $("#description").val(ev.description);
        $("#action").val(ev.action);
    });
};

getIPBWListDetail=function(ipAddr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("ipAddr", ipAddr)+",";
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/ipbwlist/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getIPBWListDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateIPBWListDetail=function() {
    var jsonStr = "{";
        
    jsonStr += jsonEncodeString("ipAddr", $("#ipAddr").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeNumber("action", $("#action").val())+",";

    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/ipbwlist/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiIPBWList.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiIPBWList.html");
        }
    });
};

delIPBWList=function(ipAddr) {    
    var indexStr = buildIndexStr(ipAddr);
    var jsonStr = "{";    
    jsonStr += jsonEncodeString("ipAddr", ipAddr)+",";    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/ipbwlist/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiIPBWListDlg.html");
};

editIPBWList=function(ipAddr) {
    var dataPost = "ipAddr="+encodeURIComponent(ipAddr);  
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiIPBWListDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiIPBWList.html");
};