
buildIndexStr=function(grp_id, caller_nbr) {
    return "grpID"+grp_id+"callerNbr"+caller_nbr;
};

getRefineClrNbrListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.grpID, ev.callerNbr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.grpID+"</td>");
        $("#"+indexStr).append("<td>"+ev.callerNbr+"</td>");
        $("#"+indexStr).append("<td>"+ev.description+"</td>");
        
        if( null != ev.tranID )
        {
            $("#"+indexStr).append("<td>"+ev.tranID+"</td>");
        }
        else
        {
            $("#"+indexStr).append("<td></td>");
        }
        
        $("#"+indexStr).append("<td>"+addBtnEdit(`editRefineCallerNbr(${ev.grpID},'${ev.callerNbr}')`)
                                       +addBtnDel(`delRefineCallerNbr(${ev.grpID},'${ev.callerNbr}')`)+"</td>");
    });
    
};

getRefineClrNbrList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/refineclrnbr/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getRefineClrNbrListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getRefineClrNbrList);
};

gotoNextList=function() {
    pageNext(getRefineClrNbrList);
};

getRefineClrNbrDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#grpID").val(ev.grpID);
        $("#callerNbr").val(ev.callerNbr);
        $("#description").val(ev.description);
        
        if( null != ev.tranID )
        {
            $("#tranID").val(ev.tranID);
        }
    });
};

getRefineClrNbrDetail=function(grp_id, caller_nbr) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("grpID", grp_id)+",";
    jsonStr += jsonEncodeString("callerNbr", caller_nbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/refineclrnbr/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getRefineClrNbrDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateRefineClrNbrDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeString("callerNbr", $("#callerNbr").val())+",";
    jsonStr += jsonEncodeNumber("grpID", $("#grpID").val())+",";
    
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeNumber("tranID", $("#tranID").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/refineclrnbr/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiRefineCallerNbr.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiRefineCallerNbr.html");
        }
    });
};

delRefineCallerNbr=function(grp_id, caller_nbr) {
    var indexStr = buildIndexStr(grp_id, caller_nbr);
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("grpID", grp_id)+",";
    jsonStr += jsonEncodeString("callerNbr", caller_nbr);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/refineclrnbr/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiRefineCallerNbrDlg.html");
};

editRefineCallerNbr=function(grp_id, caller_nbr) {
    var dataPost = "callerNbr="+encodeURIComponent(caller_nbr);    
    dataPost += "&grpID="+encodeURIComponent(grp_id); 
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiRefineCallerNbrDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiRefineCallerNbr.html");
};
