--=======================================================================
-- XML APIs provided by MSS core
--
-- Copyright (C) MYVOIPAPP,Inc. All Rights Reserved.
--
-- author: Gilson
--
-- History:
-- 2016-08-19 Created
--=======================================================================
require "utils.data_type"

function xmlOpen(fileName)
    local xmlDoc = ssfXmlOpen(fileName)
    if xmlDoc==nil or xmlDoc==0 then return nil end

    return xmlDoc
end


function xmlClose(xmlDoc)
    if xmlDoc==nil then return end

    ssfXmlClose(xmlDoc)    
end


function xmlElementsByTagName(xmlDoc, tagName)
    if xmlDoc==nil or tagName==nil then return 0 end

    local count = ssfXmlGetElementsByTagName(xmlDoc, tagName)
    return count
end


function xmlGetElementData(xmlDoc)
    if xmlDoc==nil then return nil end

    local data=ssfXmlGetElementData(xmlDoc)
    return data
end


function xmlGetElementAttr(xmlDoc, name)
    if xmlDoc==nil then return nil end 

    local attr=ssfXmlGetElementAttr(xmlDoc, name)
    return attr
end


function xmlNextElement(xmlDoc)
    if xmlDoc==nil then return MSS_ERR_FAIL end

    local result=ssfXmlNextElement(xmlDoc)
    if MSS_ERR_OK==result then 
        return MSS_ERR_OK 
    else 
        return MSS_ERR_INVALID_OBJ 
    end 
end


function xmlNextElementByName(xmlDoc, name)
    if xmlDoc==nil then return MSS_ERR_FAIL end

    local result=ssfXmlNextElementByTagName(xmlDoc,name)
    if MSS_ERR_OK==result then 
        return MSS_ERR_OK 
    else 
        return MSS_ERR_INVALID_OBJ 
    end 
end


function xmlPrevElement(xmlDoc)
    if xmlDoc==nil then return MSS_ERR_FAIL end

    local result=ssfXmlPrevElement(xmlDoc)
    if MSS_ERR_OK==result then 
        return MSS_ERR_OK 
    else 
        return MSS_ERR_INVALID_OBJ 
    end 
end


function xmlParentElement(xmlDoc)
    if xmlDoc==nil then return MSS_ERR_FAIL end

    local result=ssfXmlParentElement(xmlDoc)
    if MSS_ERR_OK==result then 
        return MSS_ERR_OK 
    else 
        return MSS_ERR_INVALID_OBJ 
    end 
end


function xmlChildElement(xmlDoc)
    if xmlDoc==nil then return MSS_ERR_FAIL end

    local result=ssfXmlChildElement(xmlDoc)
    if MSS_ERR_OK==result then 
        return MSS_ERR_OK 
    else 
        return MSS_ERR_INVALID_OBJ 
    end 
end

function xmlChildElementByName(xmlDoc, name)
    if xmlDoc==nil then return MSS_ERR_FAIL end

    local result=ssfXmlChildElementByTagName(xmlDoc,name)
    if MSS_ERR_OK==result then 
        return MSS_ERR_OK 
    else 
        return MSS_ERR_INVALID_OBJ 
    end 
end
